Index: src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessAccess.java
===================================================================
--- src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessAccess.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessAccess.java	(revision 6744)
@@ -921,10 +907,7 @@
 	private void validateDocXMLAccessList(Vector<XMLAccessDAO> xmlAccessList) throws PermOrderException {
 		String permOrder = null;
 		for(XMLAccessDAO xmlAccessDAO : xmlAccessList) {
-			String daoId = xmlAccessDAO.getDocId();
-			if (idAttribute.equals(GUID)) {
-				daoId = xmlAccessDAO.getGuid();
-			}
+			String daoId = xmlAccessDAO.getGuid();
 			if (permOrder == null) {
 				permOrder = xmlAccessDAO.getPermOrder();
 			} else {
@@ -949,7 +932,7 @@
 		
 		boolean allowFirst = false;
 		boolean denyFirst = false;
-		String id = null;
+		String guid = null;
 		
 		// These vectors will hold all combinations of access DAOs with different permission
 		// orders and permission types.  
@@ -960,13 +943,10 @@
 		
 		// sort the access dao records into the appropriate vector
 		for(XMLAccessDAO xmlAccessDAO : xmlAccessList) {
-			String daoId = xmlAccessDAO.getDocId();
-			if (idAttribute.equals(GUID)) {
-				daoId = xmlAccessDAO.getGuid();
+			String daoId = xmlAccessDAO.getGuid();
+			if (guid == null) {
+				guid = daoId;
 			}
-			if (id == null) {
-				id = daoId;
-			}
 			if (xmlAccessDAO.getPermOrder().equals(AccessControlInterface.ALLOWFIRST)) {
 				allowFirst = true;
 				if (xmlAccessDAO.getPermType().equals(AccessControlInterface.ALLOW)) {
@@ -1000,7 +980,7 @@
 		// document
 		if(allowFirst && denyFirst) {
 			throw new PermOrderException("XMLAccessAccess.validatePrincipalXMLAccessList - " + 
-					" Conflicting permission orders for document " + id +
+					" Conflicting permission orders for document " + guid +
 					". Database intervention required ");
 		}	
 	}
@@ -1015,7 +995,7 @@
 	protected XMLAccessDAO populateDAO(ResultSet resultSet) throws SQLException {
 
 		XMLAccessDAO xmlAccessDAO = new XMLAccessDAO();
-		xmlAccessDAO.setDocId(resultSet.getString(idAttribute));
+		xmlAccessDAO.setGuid(resultSet.getString("guid"));
 		xmlAccessDAO.setAccessFileId(resultSet.getString("accessfileid"));
 		xmlAccessDAO.setPrincipalName(resultSet.getString("principal_name"));
 		xmlAccessDAO.setPermission(resultSet.getLong("permission"));
Index: src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessDAO.java
===================================================================
--- src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessDAO.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/accesscontrol/XMLAccessDAO.java	(revision 6744)
@@ -39,7 +39,6 @@
  */
 public class XMLAccessDAO extends BaseDAO {
 
-	private String _docId = null;
 	private String _guid = null;
 	private String _accessFileId = null;
 	private String _principalName = null;
@@ -52,19 +51,7 @@
 	private String _subTreeId = null;
 	private String _startNodeId = null;
 	private String _endNodeId = null;
-
-	public String getDocId() {
-		return _docId;
-	}
 	
-	public void setDocId(String docId) {
-		if (docId != null && docId.equals("")) {
-			docId = null;
-		} else {
-			_docId = docId;
-		}
-	}
-	
 	public String getGuid() {
 		return _guid;
 	}
Index: src/edu/ucsb/nceas/metacat/accesscontrol/AccessControlForSingleFile.java
===================================================================
--- src/edu/ucsb/nceas/metacat/accesscontrol/AccessControlForSingleFile.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/accesscontrol/AccessControlForSingleFile.java	(revision 6744)
@@ -42,7 +42,10 @@
 import org.xml.sax.XMLReader;
 import org.xml.sax.helpers.XMLReaderFactory;
 
+import edu.ucsb.nceas.metacat.DBUtil;
 import edu.ucsb.nceas.metacat.DocInfoHandler;
+import edu.ucsb.nceas.metacat.IdentifierManager;
+import edu.ucsb.nceas.metacat.McdbDocNotFoundException;
 import edu.ucsb.nceas.metacat.McdbException;
 import edu.ucsb.nceas.metacat.PermissionController;
 import edu.ucsb.nceas.metacat.database.DBConnection;
@@ -61,9 +64,9 @@
 public class AccessControlForSingleFile implements AccessControlInterface 
 {
 
-  private String _docId;
+  private String _guid;
+  
   private Logger logMetacat = Logger.getLogger(AccessControlForSingleFile.class);
-
  
     /**
 	 * Construct an instance of the AccessControlForSingleFile class.  This
@@ -75,14 +78,50 @@
 	public AccessControlForSingleFile(String accessionNumber)
 			throws AccessControlException {
 
-		// Get rid of dev if myaccessNumber has one;
-		_docId = DocumentUtil.getDocIdFromString(accessionNumber);
-		if (_docId == null || _docId.equals("")) {
-			throw new AccessControlException("AccessControlForSingleFile() - Accession number "
-							+ "can't be null in constructor");
+		// this is a local metacat id
+		String docid = DocumentUtil.getDocIdFromString(accessionNumber);
+		// get the revision
+		String revision = DocumentUtil.getRevisionStringFromString(accessionNumber);
+		int rev = -1;
+		if (revision != null) {
+			// we were given it
+			rev = Integer.valueOf(revision);
+		} else {
+			// look up the latest
+			try {
+				rev = DBUtil.getLatestRevisionInDocumentTable(docid);
+			} catch (SQLException e) {
+				AccessControlException ace = new AccessControlException(e.getMessage());
+				ace.initCause(e);
+				throw ace;
+			}
+			if (rev <= 0) {
+				// look in the revisions table
+				try {
+					rev = DBUtil.getMaxRevFromRevisionTable(docid);
+				} catch (SQLException e) {
+					AccessControlException ace = new AccessControlException(e.getMessage());
+					ace.initCause(e);
+					throw ace;
+				}
+			}
 		}
+		
+		// find the guid for this docid.rev
+		try {
+			_guid = IdentifierManager.getInstance().getGUID(docid, rev);
+		} catch (McdbDocNotFoundException e) {
+			AccessControlException ace = new AccessControlException(e.getMessage());
+			ace.initCause(e);
+			throw ace;
+		}
+		
+		// couldn't find it?
+		if (_guid == null || _guid.equals("")) {
+			throw new AccessControlException("Guid cannot be null");
+		}
 
-		logMetacat.debug("AccessControlForSingleFile() - docid: " + _docId);
+		logMetacat.debug("AccessControlForSingleFile() - docid: " + _guid);
 	}
   
   	/**
@@ -118,7 +157,7 @@
 			// doc id.
 			XMLAccessAccess xmlAccessAccess = new XMLAccessAccess();
 			//System.out.println("permission in accessControlForSingleFile.insertPermissions: " + permission);
-			xmlAccessAccess.addXMLAccess(_docId, principalName, new Long(permission), permType, permOrder, accessFileId, subTreeId);
+			xmlAccessAccess.addXMLAccess(_guid, principalName, new Long(permission), permType, permOrder, accessFileId, subTreeId);
 		} catch (AccessException ae) {
 			throw new AccessControlException("AccessControlForSingleFile.insertPermissions - "
 					+ "DB access error when inserting permissions: " + ae.getMessage());
@@ -137,7 +176,7 @@
 		try {	
 			// use DocInfoHandler to parse the access section into DAO objects
 			XMLReader parser = null;
-			DocInfoHandler docInfoHandler = new DocInfoHandler(_docId); 
+			DocInfoHandler docInfoHandler = new DocInfoHandler(_guid); 
 			ContentHandler chandler = docInfoHandler;
 
 			// Get an instance of the parser
@@ -155,7 +194,7 @@
 				
 			// replace all access on the document
 	        Vector<XMLAccessDAO> accessControlList = docInfoHandler.getAccessControlList();
-	        xmlAccessAccess.replaceAccess(_docId, accessControlList);
+	        xmlAccessAccess.replaceAccess(_guid, accessControlList);
 
 		} catch (PropertyNotFoundException pnfe) {
 			throw new AccessControlException("AccessControlForSingleFile.insertPermissions - "
@@ -199,7 +238,7 @@
 				"AND perm_order = ? ");
      
 			// Bind the values to the query
-			pstmt.setString(1, _docId);
+			pstmt.setString(1, _guid);
 			pstmt.setString(2, xmlAccessDAO.getPrincipalName());
 			pstmt.setLong(3, xmlAccessDAO.getPermission());
 			pstmt.setString(4, xmlAccessDAO.getPermType());
@@ -246,7 +285,7 @@
 		try {   
 			hasPermission = isOwned(user);
 			if (!hasPermission) {
-				PermissionController controller = new PermissionController(_docId);
+				PermissionController controller = new PermissionController(_guid);
 				hasPermission = 
 					controller.hasPermission(user, groups, READSTRING);
 			}
@@ -257,7 +296,7 @@
 			if (hasPermission) {
 				// Get a list of all access dao objects for this docid
 				XMLAccessAccess xmlAccessAccess = new XMLAccessAccess();
-				Vector<XMLAccessDAO> xmlAccessDAOList = xmlAccessAccess.getXMLAccessForDoc(_docId);
+				Vector<XMLAccessDAO> xmlAccessDAOList = xmlAccessAccess.getXMLAccessForDoc(_guid);
 				output.append(getAccessString(xmlAccessDAOList));
 			} else {
 				output.append(getAccessString(new Vector<XMLAccessDAO>()));
@@ -288,7 +327,7 @@
 		try {
 			// Get a list of all access dao objects for this docid
 			XMLAccessAccess xmlAccessAccess = new XMLAccessAccess();
-			xmlAccessDAOList = xmlAccessAccess.getXMLAccessForDoc(_docId);
+			xmlAccessDAOList = xmlAccessAccess.getXMLAccessForDoc(_guid);
 		} catch (AccessException ae) {
 				throw new AccessControlException("AccessControlForSingleFile.getAccessString() - DB access error when " + 
 						"getting access string: " + ae.getMessage());
@@ -324,7 +363,7 @@
 			subtreeid = xmlAccessDAOList.get(0).getSubTreeId();
 		}
 
-		output.append("<access authSystem=\"knb\" order=\"" + permOrder + "\" id=\"" + _docId + "\" scope=\"document\"");
+		output.append("<access authSystem=\"knb\" order=\"" + permOrder + "\" id=\"" + _guid + "\" scope=\"document\"");
 		if (accessfileid != null) {
 			output.append(" accessfileid=\"" + accessfileid + "\"");
 		}
@@ -398,7 +437,7 @@
 			serialNumber = conn.getCheckOutSerialNumber();
 			pstmt = conn.prepareStatement("SELECT 'x' FROM xml_documents "
 					+ "WHERE docid = ? " + "AND user_owner = ?");
-			pstmt.setString(1, _docId);
+			pstmt.setString(1, _guid);
 			pstmt.setString(2, user);
 			pstmt.execute();
 			ResultSet rs = pstmt.getResultSet();
Index: src/edu/ucsb/nceas/metacat/clientview/ClientViewHelper.java
===================================================================
--- src/edu/ucsb/nceas/metacat/clientview/ClientViewHelper.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/clientview/ClientViewHelper.java	(revision 6744)
@@ -15,6 +15,8 @@
 import com.oreilly.servlet.multipart.Part;
 
 import edu.ucsb.nceas.metacat.DocInfoHandler;
+import edu.ucsb.nceas.metacat.IdentifierManager;
+import edu.ucsb.nceas.metacat.McdbDocNotFoundException;
 import edu.ucsb.nceas.metacat.accesscontrol.AccessControlException;
 import edu.ucsb.nceas.metacat.accesscontrol.AccessControlForSingleFile;
 import edu.ucsb.nceas.metacat.accesscontrol.AccessControlInterface;
@@ -505,7 +507,7 @@
     }
     
     private String setPublicAccess(String permissionType, String metaDocId, Stack docIdStack)
-    throws InsufficientKarmaException, MetacatException, MetacatInaccessibleException, AccessControlException{
+    throws InsufficientKarmaException, MetacatException, MetacatInaccessibleException, AccessControlException, McdbDocNotFoundException{
         String                      result = " for Documents ";
         String                      docId, lst = metaDocId, permOrder;
         
@@ -534,7 +536,7 @@
      * Second, remove all access rules of the user public, then add the new rules. 
      */
     private void setPublicReadAccess(String permissionType, String docid) 
-        throws InsufficientKarmaException, MetacatException, MetacatInaccessibleException, AccessControlException{
+        throws InsufficientKarmaException, MetacatException, MetacatInaccessibleException, AccessControlException, McdbDocNotFoundException{
       String originalAccessBlock = getMetacatClient().getAccessControl(docid);
       Vector<XMLAccessDAO> accessList = parseAccessXMLBlock(docid, originalAccessBlock);
       if(accessList != null  && !accessList.isEmpty()) {
@@ -607,10 +609,12 @@
      * Populate xmlAccessDAO object with the some parameters.
      */
     private XMLAccessDAO generateXMLAccessDAO(String docid, String principalName,
-        String permission, String permType, String permOrder) {
-      String identifier = DocumentUtil.getDocIdFromString(docid);
+        String permission, String permType, String permOrder) throws McdbDocNotFoundException {
+      String localId = DocumentUtil.getDocIdFromString(docid);
+      int rev = DocumentUtil.getRevisionFromAccessionNumber(docid);
+      String identifier = IdentifierManager.getInstance().getGUID(localId, rev);
       XMLAccessDAO xmlAccessDAO = new XMLAccessDAO();
-      xmlAccessDAO.setDocId(identifier);
+      xmlAccessDAO.setGuid(identifier);
       xmlAccessDAO.setPrincipalName(principalName);
       xmlAccessDAO.setPermission(Integer.valueOf(AccessControlList.intValue(permission)).longValue());
       xmlAccessDAO.setPermType(permType);
Index: src/edu/ucsb/nceas/metacat/PermissionController.java
===================================================================
--- src/edu/ucsb/nceas/metacat/PermissionController.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/PermissionController.java	(revision 6744)
@@ -53,7 +53,11 @@
 
 public class PermissionController
 {
-   private String docId = null;
+//   private String docId = null;
+//   private int rev = -1;
+   
+   private String guid = null;
+   
    private boolean hasSubTreeAccessControl = false; // flag if has a subtree
                                                     // access for this docid
    private Vector subTreeList = new Vector();
@@ -64,33 +68,25 @@
    private static Logger logMetacat = Logger.getLogger(PermissionController.class);
 
    /**
-    * Constructor for PermissionController
-    * @param myDocid      the docid need to access
-    */
-   public PermissionController(String myDocid) throws McdbException
-   {
-     // Get rid of rev number
-     docId = DocumentUtil.getSmartDocId(myDocid);
-     //hasSubTreeAccessControl = checkSubTreeAccessControl();
-   }
+	 * Constructor for PermissionController
+	 * 
+	 * @param myDocid the docid need to access
+	 */
+	public PermissionController(String myDocid) throws McdbException {
 
-   /**
-    * Constructor for PermssionController
-    * @param myDocid String
-    * @param needDeleteRev boolean
-    */
-   public PermissionController(String myDocid, boolean needDeleteRevFromDocid)
-   {
-     if (!needDeleteRevFromDocid)
-     {
-       docId = myDocid;
-     }
-     else
-     {
-         docId = DocumentUtil.getDocIdFromAccessionNumber(myDocid);
-     }
-   }
+		// find the guid if we can
+		String docId = null;
+		int rev = -1;
 
+		// get the parts
+		docId = DocumentUtil.getSmartDocId(myDocid);
+		rev = DocumentUtil.getRevisionFromAccessionNumber(myDocid);
+
+		// this is what we really want
+		guid = IdentifierManager.getInstance().getGUID(docId, rev);
+
+	}
+
    /**
     * Return if a document has subtree access control
     */
@@ -147,15 +143,15 @@
     //if the requested document is access documents and requested permission
     //is "write", the user should have "all" right
 
-    if (isAccessDocument(docId) && (permission == AccessControlInterface.WRITE))
+    if (isAccessDocument() && (permission == AccessControlInterface.WRITE))
     {
 
-      hasPermission = hasPermission(userPackage,docId, 7);// 7 is all permission
+      hasPermission = hasPermission(userPackage, 7);// 7 is all permission
     }//if
     else //in other situation, just check the request permission
     {
       // Check for @permission on @docid for @user and/or @groups
-      hasPermission = hasPermission(userPackage,docId, permission);
+      hasPermission = hasPermission(userPackage, permission);
     }//else
 
     return hasPermission;
@@ -169,8 +165,7 @@
     * @param docid, document identifier to check on
     * @param permission, permission (write or all...) to check for
     */
-  private boolean hasPermission(String [] principals, String docId,
-                                           int permission)
+  private boolean hasPermission(String [] principals, int permission)
                          throws SQLException
   {
     long startId = TOPLEVELSTARTNODEID;// this is for top level, so startid is 0
@@ -178,7 +173,7 @@
     {
       //first, if there is a docid owner in user package, return true
       //because doc owner has all permssion
-      if (containDocumentOwner(principals, docId))
+      if (containDocumentOwner(principals))
       {
 
           return true;
@@ -186,10 +181,10 @@
 
       //If there is no owner in user package, checking the table
       //check perm_order
-      if (isAllowFirst(principals, docId, startId))
+      if (isAllowFirst(principals, startId))
       {
 
-        if (hasExplicitDenyRule(principals, docId, permission, startId))
+        if (hasExplicitDenyRule(principals, permission, startId))
         {
           //if it is allowfirst and has deny rule(either explicit )
           //deny access
@@ -196,7 +191,7 @@
 
           return false;
         }//if
-        else if ( hasAllowRule(principals, docId, permission, startId))
+        else if ( hasAllowRule(principals, permission, startId))
         {
           //if it is allowfirst and hasn't deny rule and has allow rule
           //allow access
@@ -212,7 +207,7 @@
      }//if isAllowFirst
      else //denyFirst
      {
-       if (hasAllowRule(principals, docId, permission, startId))
+       if (hasAllowRule(principals, permission, startId))
        {
          //if it is denyFirst and has allow rule, allow access
          return true;
@@ -251,14 +246,15 @@
      // from inlinedataId directly. You should get it from eml document itself
      String []userPackage = createUsersPackage(user, groups);
      try {
-        if (containDocumentOwner(userPackage, docId))
+        if (containDocumentOwner(userPackage))
          {
            return true;
          }
          else
          {
-             PermissionController controller =
-                                   new PermissionController(inlineDataId, false);
+        	 // is a funky inline data id with the extra part, so we set it manually
+             PermissionController controller = new PermissionController(guid);
+             controller.guid = inlineDataId;
              return controller.hasPermission(user, groups, myPermission);
          }
     } catch (SQLException e) {
@@ -318,7 +314,7 @@
     //for the document owner return null(no unaccessable subtree)
     try
     {
-      if (containDocumentOwner(principals, docId))
+      if (containDocumentOwner(principals))
       {
        return resultUnaccessableSubTree;
       }
@@ -337,10 +333,10 @@
 
         try
         {
-          if (isAllowFirst(principals, docId, startId))
+          if (isAllowFirst(principals, startId))
           {
 
-            if (hasExplicitDenyRule(principals, docId, permission, startId ))
+            if (hasExplicitDenyRule(principals, permission, startId ))
             {
 
              //if it is allowfirst and has deny rule
@@ -350,7 +346,7 @@
                 resultUnaccessableSubTree.put(new Long(startId), tree);
               }
             }//if
-            else if ( hasAllowRule(principals, docId, permission, startId))
+            else if ( hasAllowRule(principals, permission, startId))
             {
               //if it is allowfirst and hasn't deny rule and has allow rule
               //allow access do nothing
@@ -368,7 +364,7 @@
           }//if isAllowFirst
           else //denyFirst
           {
-            if (hasAllowRule(principals, docId, permission,startId))
+            if (hasAllowRule(principals, permission,startId))
             {
               //if it is denyFirst and has allow rule, allow access, do nothing
 
@@ -463,8 +459,16 @@
 	 * @param docId,
 	 *            the document id need to be checked
 	 */
-	private boolean isAccessDocument(String docId) throws SQLException {
-		// detele the rev number if docid contains it
+	private boolean isAccessDocument() throws SQLException {
+		// get the docid from the guid
+		String docId = null;
+		try {
+			docId = IdentifierManager.getInstance().getLocalId(guid);
+		} catch (McdbDocNotFoundException e) {
+			return false;
+			//throw new SQLException(e);
+		}
+
 		docId = DocumentUtil.getDocIdFromString(docId);
 		PreparedStatement pStmt = null;
 		DBConnection conn = null;
@@ -520,9 +524,20 @@
 	 * @param docid,
 	 *            the id of given documents
 	 */
-  private boolean containDocumentOwner( String[] principals, String docId)
+  private boolean containDocumentOwner(String[] principals)
                     throws SQLException
   {
+	 
+	// get the docid  
+	String docId = null;
+	try {
+		docId = IdentifierManager.getInstance().getLocalId(guid);
+		docId = DocumentUtil.getDocIdFromString(docId);
+	} catch (McdbDocNotFoundException e) {
+		// should be true if we own the parent doc, but likely won't be checked in that case
+		return false;
+	}
+	
     int lengthOfArray=principals.length;
     boolean hasRow;
     PreparedStatement pStmt=null;
@@ -593,8 +608,7 @@
     * @param principals, list of names of principals to check for
     * @param docid, document identifier to check for
     */
-  private boolean isAllowFirst(String [] principals, String docId,
-                               long startId)
+  private boolean isAllowFirst(String [] principals, long startId)
                   throws SQLException, Exception
   {
     int lengthOfArray=principals.length;
@@ -608,14 +622,19 @@
     {
       //top level
       topLever = true;
-      sql = "SELECT perm_order FROM xml_access " +
-    "WHERE lower(principal_name) = ? AND docid = ? AND startnodeid is NULL";
+      sql = 
+    	  "SELECT perm_order FROM xml_access " +
+		    "WHERE lower(principal_name) = ? " +
+		    "AND guid = ? " +
+		    "AND startnodeid is NULL";
     }
     else
     {
       //sub tree level
       sql = "SELECT perm_order FROM xml_access " +
-        "WHERE lower(principal_name)= ? AND docid = ? AND startnodeid = ?";
+        "WHERE lower(principal_name) = ? " +
+        "AND guid = ? " +
+        "AND startnodeid = ?";
     }
 
     try
@@ -632,8 +651,8 @@
       {
         //bind value
         pStmt.setString(1, principals[i]);//user name
-        pStmt.setString(2, docId);//docid
-
+        pStmt.setString(2, guid);//guid
+        
         // if subtree, we need set subtree id
         if (!topLever)
         {
@@ -681,7 +700,7 @@
     //docid. So throw a exception.
 
     throw new Exception("PermissionController.isAllowFirst - There is no permission record for user "+ principals[0] + 
-                        " at document " + docId);
+                        " at document " + guid);
 
   }//isAllowFirst
 
@@ -694,8 +713,7 @@
     * @param docid, document identifier to check for
     * @param permission, the permssion need to check
     */
-  private boolean hasAllowRule(String [] principals, String docId,
-                                  int permission, long startId)
+  private boolean hasAllowRule(String [] principals, int permission, long startId)
                   throws SQLException, Exception
  {
    int lengthOfArray=principals.length;
@@ -704,7 +722,6 @@
    PreparedStatement pStmt = null;
    int permissionValue=permission;
    int permissionValueInTable;
-   int ticketCount;
    DBConnection conn = null;
    int serialNumber = -1;
    boolean topLever = false;
@@ -713,14 +730,22 @@
    {
      // for toplevel
      topLever = true;
-     sql = "SELECT permission FROM xml_access WHERE docid = ? " +
-   "AND lower(principal_name) = ? AND perm_type = ? AND startnodeid is NULL";
+     sql = "SELECT permission " +
+		"FROM xml_access " +
+ 		"WHERE guid = ? " +
+ 		"AND lower(principal_name) = ? " +
+ 		"AND perm_type = ? " +
+ 		"AND startnodeid is NULL";
    }
    else
    {
      topLever =false;
-     sql = "SELECT permission FROM xml_access WHERE docid = ? " +
-      "AND lower(principal_name) = ? AND perm_type = ? AND startnodeid = ?";
+     sql = "SELECT permission " +
+     		"FROM xml_access " +
+     		"WHERE guid = ? " +
+     		"AND lower(principal_name) = ? " +
+     		"AND perm_type = ? " +
+     		"AND startnodeid = ?";
    }
    try
    {
@@ -733,7 +758,7 @@
     //function will assign begin_time=sysdate
     pStmt = conn.prepareStatement(sql);
     //bind docid, perm_type
-    pStmt.setString(1, docId);
+    pStmt.setString(1, guid);
     pStmt.setString(3, AccessControlInterface.ALLOW);
 
     // if subtree lever, need to set subTreeId
@@ -794,7 +819,7 @@
     * @param docid, document identifier to check for
     * @param permission, the permssion need to check
     */
-  private boolean hasExplicitDenyRule(String [] principals, String docId,
+  private boolean hasExplicitDenyRule(String [] principals,
                                       int permission, long startId)
                   throws SQLException
  {
@@ -812,14 +837,22 @@
    if (startId == TOPLEVELSTARTNODEID)
    {
      topLevel = true;
-     sql = "SELECT permission FROM xml_access WHERE docid = ? " +
-    "AND lower(principal_name) = ? AND perm_type = ? AND startnodeid is NULL";
+     sql = "SELECT permission " +
+     		"FROM xml_access " +
+     		"WHERE guid = ? " +
+	     	"AND lower(principal_name) = ? " +
+	     	"AND perm_type = ? " +
+	     	"AND startnodeid is NULL";
    }
    else
    {
      topLevel = false;
-     sql = "SELECT permission FROM xml_access WHERE docid = ? " +
-     "AND lower(principal_name) = ? AND perm_type = ? AND startnodeid = ?";
+     sql = "SELECT permission " +
+		"FROM xml_access " +
+		"WHERE guid = ? " +
+	  	"AND lower(principal_name) = ? " +
+	  	"AND perm_type = ? " +
+	  	"AND startnodeid = ?";
    }
 
    try
@@ -830,7 +863,7 @@
 
      pStmt = conn.prepareStatement(sql);
     //bind docid, perm_type
-    pStmt.setString(1, docId);
+    pStmt.setString(1, guid);
     pStmt.setString(3, AccessControlInterface.DENY);
 
     // subtree level need to set up subtreeid
@@ -978,19 +1011,17 @@
    * user can't read it. The key is subtree id of inlinedata, the data is
    * internal file name for the inline data which is stored as docid
    * in xml_access table or data object doc id.
-   * @param docidWithoutRev, metadata docid which should be the accessfileid
+   * @param docid (With Rev), metadata docid which should be the accessfileid
    *                         in the table
    * @param user , the name of user
    * @param groups, the group which the user belong to
    */
-   public static Hashtable<String, String> getUnReadableInlineDataIdList(String docidWithoutRev,
-                                                   String user, String[] groups,
-                                                   boolean withRevision)
+   public static Hashtable<String, String> getUnReadableInlineDataIdList(String docid,
+                                                   String user, String[] groups)
                                                 throws McdbException
    {
-     Hashtable<String, String> inlineDataList = getUnAccessableInlineDataIdList(docidWithoutRev,
-                              user, groups, AccessControlInterface.READSTRING,
-                              withRevision);
+     Hashtable<String, String> inlineDataList = getUnAccessableInlineDataIdList(docid,
+                              user, groups, AccessControlInterface.READSTRING);
 
      return inlineDataList;
    }
@@ -1011,24 +1042,19 @@
                                                throws Exception
   {
     Hashtable<String, String> inlineDataList = getUnAccessableInlineDataIdList(docidWithoutRev,
-                            user, groups, AccessControlInterface.WRITESTRING,
-                            withRevision);
+                            user, groups, AccessControlInterface.WRITESTRING);
 
     return inlineDataList;
   }
 
 
-   /*
+   /**
     * This method will get hashtable which contains a unaccessable distribution
     * inlinedata object list
     *
-    * withRevision is used to get inline id list with or without revision number
-    * e.g. when withRevision is true, temp.1.1.1, temp.1.1.2 would be returned
-    * otherwise temp.1.1 and temp.1.2 would be returned.
     */
    private static Hashtable<String, String> getUnAccessableInlineDataIdList(String docid,
-                               String user, String[] groups, String permission,
-                               boolean withRevision)
+                               String user, String[] groups, String permission)
                              throws McdbException
    {
        Hashtable<String, String> unAccessibleIdList = new Hashtable();
@@ -1047,30 +1073,19 @@
       {
         String subTreeId = (String) en.nextElement();
         String fileId = (String) allIdList.get(subTreeId);
-        //Here fileid is internal file id for line data. It stored in docid
-        // field in xml_access table. so we don't need to delete rev
-        PermissionController controller = new PermissionController(docid, false);
+        //Here fileid is internal file id for line data. It stored in guid
+        // field in xml_access table. 
+        PermissionController controller = new PermissionController(docid);
         if (!controller.hasPermissionForInlineData(user, groups, permission, fileId))
         {
-            if(withRevision)
-            {
-                logMetacat.info("PermissionController.getUnAccessableInlineDataIdList - Put subtree id " + subTreeId +
-                                         " and " + "inline data file name " +
-                                         fileId + " into " + "un" + permission +
-                                         " hash");
-                unAccessibleIdList.put(subTreeId, fileId);
+            
+            logMetacat.info("PermissionController.getUnAccessableInlineDataIdList - Put subtree id " + subTreeId +
+                                     " and " + "inline data file name " +
+                                     fileId + " into " + "un" + permission +
+                                     " hash");
+            unAccessibleIdList.put(subTreeId, fileId);
 
-            }
-            else
-            {
-                logMetacat.info("PermissionController.getUnAccessableInlineDataIdList - Put subtree id " + subTreeId +
-                                         " and " + "inline data file name " +
-                                         DocumentUtil.getInlineDataIdWithoutRev(fileId) +
-                                         " into " + "un" + permission +
-                                         " hash");
-                unAccessibleIdList.put(subTreeId, 
-                		DocumentUtil.getInlineDataIdWithoutRev(fileId));
-            }
+                        
         }
       }
       return unAccessibleIdList;
@@ -1085,8 +1100,11 @@
    private static Hashtable getAllInlineDataIdList(String docid) throws SQLException
    {
      Hashtable inlineDataList = new Hashtable();
-     String sql = "SELECT subtreeid, docid FROM xml_access WHERE " +
-                   "accessfileid = ? AND subtreeid  IS NOT NULL";
+     String sql = 
+    	 "SELECT subtreeid, guid " +
+    	 "FROM xml_access " +
+    	 "WHERE accessfileid = ? " +
+    	 "AND subtreeid IS NOT NULL";
      PreparedStatement pStmt=null;
      ResultSet rs=null;
      DBConnection conn=null;
